#***********************************************************************#
#                                                                       #
#   Module:         MAXINC                                              #
#                                                                       #
#   Description:    This is a makefile for AHDL include files.          #
#                                                                       # 
#   Author:         Kerry Veenstra                                      #
#                   Copyright (c) Altera Corporation 1989               #
#                                                                       #
#   Date:           8/03/89                                             #
#                                                                       #
#***********************************************************************#

# $Log:   X:/CODE/MAXINC/MAKEFILE.MA_  $
#    
#       Rev 21.4   08 Sep 1995 12:13:40   marcel
#    Moved pll and ntcs from ASF dir to LPMLIB (mega_lpm) dir. SPR 30705.
#    
#       Rev 21.3   24 Jul 1995 14:37:50   albert
#    fixed upper case problem on workstation
#    
#       Rev 21.2   26 Jun 1995 14:58:20   dennis
#    Initial MainWin Port
#    
#       Rev 21.1   15 May 1995 16:26:12   jeffc
#    Added memmodes.inc
#    
#       Rev 21.0   29 Nov 1994 15:08:50   max
#    Max+Plus II 6.0
#    
#       Rev 20.0   07 Sep 1994 13:21:50   max
#    Max+Plus II 5.2
#    
#       Rev 19.0   10 Aug 1994 10:48:08   max
#    Max+plus II 5.0
#    
#       Rev 18.1   02 Jun 1994 10:32:50   ykn
#    Included 81mux.inc
#    
#       Rev 18.0   07 Jan 1994 23:14:38   max
#    MAX+plus II 4.01
#    
#       Rev 17.1   08 Sep 1993 17:37:28   scottm
#    Added 7473a 7476a 7478a and 74107a, see spr 19416
#    
#       Rev 17.0.1.1   08 Sep 1993 17:33:28   scottm
#    Added 7473a 7476a 7478a and 74107a, see spr 19416
#    
#       Rev 17.0.1.0   22 Jul 1993 17:10:20   max
#    MAX+plus II 3.20
#    
#       Rev 17.0   22 Jul 1993 17:10:20   max
#    MAX+plus II 3.20
#    
#       Rev 16.3   13 Jul 1993 10:44:30   scottm
#    see spr 19027
#    
#       Rev 16.2   04 Jun 1993 10:55:40   max
#    Added btri.inc, See spr# 14892
#    
#       Rev 16.1   19 Apr 1993 11:40:30   scottm
#    Added 74990.inc and 161mux.inc
#    
#       Rev 16.0   31 Mar 1993 18:02:14   max
#    MAX+plus II 3.10
#    
#       Rev 15.0   04 Feb 1993 21:12:52   max@ev11
#    MAX+plus II 3.01
#    
#       Rev 14.0   16 Dec 1992 02:23:32   max
#    MAX+plus II 3.00
#    
#       Rev 13.1   04 Sep 1992 16:18:00   subroto@de13
#    Added 8DFF, 74374NT, 8DFFE.
#    
#       Rev 13.0   05 Mar 1992 12:45:20   dell8
#    MAX+plus II 2.00
#    
#       Rev 12.1   14 Feb 1992 15:27:38   jay
#    added ntsc.inc and pll.inc for ASF files
#    
#       Rev 12.0   27 Aug 1991 19:45:14   tim
#    MAX+PLUS II 1.11
#    
#       Rev 11.0   03 Jun 1991 19:09:48   tim
#    MAX+PLUS II 1.00
#    
#       Rev 10.2   26 Feb 1991 11:20:16   kerry
#    Added MAXES and MAX55
#    
#       Rev 10.1   18 Sep 1990 11:06:54   david
#    Includes ..\builtins.mak
#    
#       Rev 10.0   24 Jul 1990  8:24:18   max
#    Fork_to_allow_windows_and_dos_development
#    
#       Rev 9.0   08 Jun 1990 14:38:48   max
#    2.50
#    
#       Rev 7.0   18 Oct 1989 19:54:40   max
#    2.00
#    
#       Rev 1.2   08 Sep 1989 17:48:12   kerry
#    Changed to conform to Tim's memo MAX+PLUS Makefile Changes.
#    
#       Rev 1.1   03 Aug 1989 15:59:08   kerry
#    Added bus macrofunctions.
#    
#       Rev 1.0   03 Aug 1989 15:00:54   kerry
#    Initial revision.

#
#***********************************************************************#
#                                                                       #
#   Macros                                                              #
#                                                                       #
#***********************************************************************#

# This is the PVCS directory that contains the source files for this
# module.
.INCLUDE ../environ.mak
PVCS_DIR = $(PVCS_ROOT)/maxinc

ASF	= memmodes.inc

MAX33 =\
    7473a.inc 7476a.inc 7478a.inc 74107a.inc

MAX32 =\
    74990.inc 161mux.inc btri.inc

MAX30 =\
    7442.inc 7449.inc 7483.inc 7485.inc 7491.inc 7493.inc 74138.inc\
    74139.inc 74151.inc 74153.inc 74157.inc 74160.inc 74161.inc\
    74162.inc 74163.inc 74164.inc 74165.inc 74180.inc 74190.inc\
    74191.inc 74193.inc 74194.inc 74273.inc 74279.inc 74373.inc\
    74374.inc 4count.inc 8mcomp.inc 16cudslr.inc unicnt.inc 81mux.inc


MAX75 =\
    7400.inc 7402.inc 7404.inc 7408.inc 7410.inc 7411.inc 74116.inc\
    74147.inc 74148.inc 74154.inc 74155.inc 74156.inc 74158.inc\
    74166.inc 74173.inc 74174.inc 74175.inc 74178.inc 74179.inc\
    74181.inc 74183.inc 74184.inc 74185.inc 74192.inc 74198.inc\
    7420.inc 7421.inc 74259.inc 74261.inc 7427.inc 74278.inc\
    74280.inc 74298.inc 7430.inc 7432.inc 74393.inc 7443.inc 7444.inc\
    7445.inc 7446.inc 7447.inc 7448.inc 74518.inc 7452.inc 7470.inc\
    7471.inc 7472.inc 7473.inc 7474.inc 7475.inc 7476.inc 7477.inc\
    7478.inc 7480.inc 7482.inc 7486.inc 7487.inc 7494.inc 7496.inc\
    7498.inc 7499.inc 8count.inc 8fadd.inc barrelst.inc cbuf.inc\
    freqdiv.inc gray4.inc inhb.inc inpltch.inc mult2.inc mult24.inc\
    mult4.inc nandltch.inc norltch.inc 21mux.inc

BUS =\
    74151b.inc 74174b.inc 74180b.inc 74240b.inc 74241b.inc 74244b.inc\
    74280b.inc 74273b.inc 74373b.inc 74374b.inc 74518b.inc mult4b.inc\
    74821b.inc 8mcompb.inc 8faddb.inc 74822b.inc barrlstb.inc\
    16cudsrb.inc 74841b.inc 74842b.inc 74826b.inc 74823b.inc\
    74824b.inc 74825b.inc 74164b.inc 74165b.inc 74377b.inc

MAXES = \
	16dmux.inc 16ndmux.inc 74137.inc 74143.inc 74145.inc 74167.inc\
	74168.inc 74169.inc 74171.inc 74176.inc 74177.inc 74182.inc\
	74195.inc 74199.inc 74240.inc 74241.inc 74244.inc 74246.inc\
	74248.inc 74251.inc 74253.inc 74260.inc 74265.inc 74276.inc\
	74294.inc 74295.inc 74299.inc 74348.inc 74350.inc 74352.inc\
	74353.inc 74354.inc 74356.inc 74381.inc 74382.inc 74385.inc\
	74390.inc 74395.inc 74396.inc 74399.inc 74445.inc 74465.inc\
	74490.inc 7456.inc 7457.inc 74590.inc 74592.inc 74594.inc\
	74595.inc 74597.inc 74604.inc 74668.inc 74669.inc 74670.inc\
	74671.inc 74672.inc 74673.inc 74674.inc 7468.inc 74684.inc\
	74686.inc 74688.inc 7469.inc 74690.inc 74691.inc 74693.inc\
	74696.inc 74697.inc 74698.inc 74699.inc 74821.inc 74822.inc\
	74823.inc 74824.inc 74825.inc 74826.inc 74841.inc 74842.inc\
	74843.inc 74844.inc 74845.inc 74846.inc 7490.inc 7492.inc\
	7495.inc 7497.inc 2x8mux.inc enadff.inc expdff.inc explatch.inc\
	tmult4.inc 8dff.inc 74374nt.inc 8dffe.inc

MAX55 = \
	7423.inc 7425.inc 7428.inc 7437.inc 7440.inc 7450.inc 7451.inc\
	7453.inc 7454.inc 7455.inc 7464.inc 74107.inc 74109.inc 74112.inc\
	74113.inc 74114.inc 74133.inc 74134.inc 74135.inc 74172.inc\
	74196.inc 74197.inc 74247.inc 74257.inc 74258.inc 74283.inc\
	74284.inc 74285.inc 74290.inc 74292.inc 74293.inc 74297.inc\
	74365.inc 74366.inc 74367.inc 74368.inc 74375.inc 74376.inc\
	74377.inc 74378.inc 74379.inc 74386.inc 74398.inc 74466.inc\
	74467.inc 74468.inc 74540.inc 74541.inc 74548.inc 74549.inc\
	74568.inc 74569.inc 74589.inc 74630.inc 74636.inc

# Load global builtin rules.
.INCLUDE ../builtins.mak

#
#***********************************************************************#
#                                                                       #
#   Main Targets                                                        #
#                                                                       #
#***********************************************************************#

all : $(MAX33) $(MAX32) $(MAX30) $(MAX75) $(BUS) $(MAXES) $(MAX55) $(ASF)


